unit flptspeed;

{ Hans Otten, may 2009 }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DLPOrtIO, Menus ;

type
  TLPTSpeed = class(TForm)
    bcapture: TButton;
    log: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    procedure bcaptureClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const

  bufferlen = 5000000 ;


var
  LPTSpeed: TLPTSpeed;
  buffer : array[1..bufferlen] of byte  ;


implementation

{$R *.dfm}


 procedure WriteIOPort(port : integer ; value : integer) ;

  var

   lport : longint ;
   vport  : byte ;

 begin

   lport := port ;
   vport := value ;
   DlPortWritePortUchar(lport, vport) ;

 end ; { WriteIOPort }



procedure TLPTSpeed.bcaptureClick(Sender: TObject);


var


  start,stop, freq:int64;
  elapsed : extended ;
  buffercount :cardinal ;


begin

  QueryPerformanceFrequency(freq); {Get frequency}

  buffercount := 1 ;
  screen.cursor:=crHourGlass; {show busy cursor}

  {collect data }
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS   );
  SetThreadPriority( GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL  );

  QueryPerformanceCounter(start); {Get initial count}
  repeat
    buffer[buffercount] := DlPortReadPortUchar($378) ;
    buffercount := buffercount + 1 ;
  until buffercount = bufferlen ;
  QueryPerformanceCounter(stop);

  SetPriorityClass( GetCurrentProcess, NORMAL_PRIORITY_CLASS );
  SetThreadPriority( GetCurrentThread, THREAD_PRIORITY_NORMAL  );
    screen.cursor:=crDefault;  {show normal cursor}

  { report }
  elapsed := ((stop - start) * 1000) / freq  ;
  log.lines.add(FormatFloat('0.00',(elapsed))+ ' ms') ;
  elapsed := bufferlen /  (elapsed)      ;
  log.lines.add('Frequency = ' +  FormatFloat('0.00',elapsed) + 'kHz') ;




end;

procedure TLPTSpeed.Exit1Click(Sender: TObject);
begin

 halt ;

end;

procedure TLPTSpeed.About1Click(Sender: TObject);
begin

  ShowMessage('LPT Speed, Hans Otten, 2009') ;

end;

end.
